%if 0%{?_version:1}
%define         _verstr      %{_version}
%else
%define         _verstr      0.7.1
%endif
%define         _upstream_name  alertmanager
Name:           prometheus-%{_upstream_name}
Version:        %{_verstr}
Release:        1%{?dist}
Summary:        Prometheus Alertmanager

Group:          System Environment/Daemons
License:        Apache 2.0
URL:            https://prometheus.io
Source0:        https://github.com/prometheus/%{_upstream_name}/releases/download/v%{version}/%{_upstream_name}-%{version}.linux-amd64.tar.gz
Source1:        %{name}.sysconfig
Source2:        %{name}.service
Source3:        %{name}.init
Source7:        %{name}.logrotate
BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

%if 0%{?fedora} >= 14 || 0%{?rhel} >= 7
BuildRequires:  systemd-units
Requires:       systemd
%else
Requires:       logrotate
%endif
Requires(pre): shadow-utils

%description
The Alertmanager handles alerts sent by client applications such as the Prometheus server. 
It takes care of deduplicating, grouping, and routing them to the correct receiver 
integrations such as email, PagerDuty, or OpsGenie. 
It also takes care of silencing and inhibition of alerts.

%prep
%setup -q -n %{_upstream_name}-%{version}.linux-amd64

%install
mkdir -p %{buildroot}/%{_localstatedir}/log/prometheus
mkdir -p %{buildroot}/%{_bindir}
cp alertmanager %{buildroot}/%{_bindir}
cp amtool %{buildroot}/%{_bindir}

mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}/%{_sysconfdir}/prometheus
cp %{SOURCE1} %{buildroot}/%{_sysconfdir}/sysconfig/%{name}
sed -i 's|/etc/alertmanager/template|/usr/share/prometheus-alertmanager/template|g' simple.yml
cp simple.yml %{buildroot}/%{_sysconfdir}/prometheus/%{name}.yml
mkdir -p %{buildroot}/%{_sharedstatedir}/%{name}
mkdir -p %{buildroot}/%{_datadir}/%{name}/template

%if 0%{?fedora} >= 14 || 0%{?rhel} >= 7
mkdir -p %{buildroot}/%{_unitdir}
cp %{SOURCE2} %{buildroot}/%{_unitdir}/
%else
mkdir -p %{buildroot}/%{_initrddir}
mkdir -p %{buildroot}/%{_sysconfdir}/logrotate.d
cp %{SOURCE3} %{buildroot}/%{_initrddir}/%{name}
cp %{SOURCE7} %{buildroot}/%{_sysconfdir}/logrotate.d/%{name}
%endif

%pre
getent group prometheus >/dev/null || groupadd -r prometheus
getent passwd prometheus >/dev/null || \
    useradd -r -g prometheus -d /var/lib/prometheus -s /sbin/nologin \
    -c "prometheus.io user" prometheus
exit 0

%if 0%{?fedora} >= 14 || 0%{?rhel} >= 7
%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service
%else
%post
/sbin/chkconfig --add %{name}

%preun
if [ "$1" = 0 ] ; then
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %attr(750, prometheus, prometheus) %{_sharedstatedir}/%{name}
%dir %attr(755, root, root) %{_datadir}/%{name}/template
%config(noreplace) %{_sysconfdir}/prometheus/%{name}.yml
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%if 0%{?fedora} >= 14 || 0%{?rhel} >= 7
%{_unitdir}/%{name}.service
%else
%attr(755, root, root) %{_initrddir}/%{name}
%{_sysconfdir}/logrotate.d/%{name}
%endif
%attr(755, root, root) %{_bindir}/alertmanager
%attr(755, root, root) %{_bindir}/amtool
%dir %attr(700, prometheus, prometheus) %{_localstatedir}/log/prometheus
%doc LICENSE NOTICE simple.yml

%changelog
* Wed Jun 14 2017 Teguh DC <dheche@fedoraproject.org> - 0.7.1-1
- Initial rpm package
